#include "defs.h"

/*
 *  Establish connection between users.
 *
 *  <LH:881125:v2.0>
 */

void
doconnect ()
{
	mypid = getpid();

	sprintf (tempfile, "/tmp/ta_%s.%s", hisname, myname);
	
	if (!file_exist (tempfile) || out_of_date (tempfile))
	{
		unlink (tempfile);
		master_queue ();
	}
	else
		slave_queue ();

	connected = TRUE;
	wheader (mywin, "[Connected]\n");
	update_time_line ();
	beep ();
}


/*
 *  Create message queue for connection to slave and try to connect.
 *
 *  <LH:881125:v2.0>
 */

void
master_queue ()
{
	int	try;
	char	*histty;
	MSG	*msgp;

	sprintf (tempfile, "/tmp/ta_%s.%s", myname, hisname);

	if (creat (tempfile, 0) == -1)
		error("can't create %s", tempfile);

	if ((key = ftok (tempfile, '\0')) == (key_t)-1)
		error (tempfile);

	if ((msgid = msgget (key, 0)) >= 0 && msgctl (msgid, IPC_RMID,0) == -1)
		error ("Can't remove old message queue id (%d)", msgid);

	if ((msgid = msgget (key, MSGMASK | IPC_CREAT)) == -1)
		error ("Can't create new message queue.");

	histty = notify (CONNECT);

	sprintf (tmp, "[Waiting for your party to respond on %s]\n", histty);
	wheader (mywin, tmp);
	wnoutrefresh (mywin);
	doupdate ();

	for (try=1; try < MAXTRY; ++try)
	{
		sendmsg ((int)key, CONNECT);
		alarm (TRY_TIME);

		while (msgp = getmsg (mypid))
		{
			if (msgp->c == CONNECT)
			{
				hispid = msgp->from_pid;
				return;
			}
		}

		histty = notify (CONNECT);
		
		sprintf (tmp, "[Ringing your party again on %s (retry %d)]\n",
						histty, try);
		wheader (mywin, tmp);
	}

	disconnect (NO_ANSWER);
	/*NOTREACHED*/
}

/*
 *  Get message queue id for the slave connection.
 *
 *  <LH:881125:v2.0>
 */

void
slave_queue ()
{
	MSG	*msgp;

	sprintf (tempfile, "/tmp/ta_%s.%s", hisname, myname);

	if ((key = ftok (tempfile, '\0')) == (key_t)-1)
		error (tempfile);

	unlink (tempfile);

	if ((msgid = msgget (key, 0)) == -1)
		error ("msgget: can't get msgid.");

	alarm (5);
	
	if ((msgp = getmsg (ANYMSG)) == NULL)
		error ("Can't connect to master");	

	hispid = msgp->from_pid;
	sendmsg (hispid, CONNECT);
}
