#include "defs.h"

/*
 *  Talk() forks of a demon whose only task is to serve my own talk process
 *  (through the message queue) with characters read from the keyboard. Talk()
 *  interprets messages comming from my own PID as characters (or commands)
 *  to be displayed on my own window. If the character is accepteble it is 
 *  then sent over to the corresponding talk process.
 *
 *  <LH:881125:v2.0>
 */


void talk()				/*  talk to other user  */
{
	char c;
	register MSG *msgp;

	wmove (hiswin, 0, 0);		/*  start cursor positions  */
	wmove (mywin, 1, 0);

	delchar = erasechar();		/* get current erase char */

	if ((readpid = fork()) == 0)	/* fork of keyboard-read process */
	{
		setpgrp();

		while (1)
		{
			read (0, &c, 1);
			/* send char to my self */
			sendmsg (mypid, (c == delchar) ? DELETE : c); 
		}
	}
	else if (readpid == -1)
		error ("cannot fork");

	alarm (TICK_INTERVAL);		/*  trigg time counter */

	while (1)
	{
		wnoutrefresh (mywin);	/*  place cursor in my own window  */
		doupdate();		/*  update screen */

		if (msgp = getmsg (mypid)) /* returns NULL if interrupted */
		{
			if (msgp->from_pid == mypid)
				add_my_window (msgp->c);
			else if (msgp->from_pid == hispid)
				add_his_window (msgp->c);
		}

		if (time_changed)
			update_time();	/*  display elapsed time  */
	}
}

